#ifndef FLUTTER_PLUGIN_NGEX_PLUGIN_H_
#define FLUTTER_PLUGIN_NGEX_PLUGIN_H_

#include <flutter/method_channel.h>
#include <flutter/plugin_registrar_windows.h>

#include <memory>

namespace ngex {

class NgexPlugin : public flutter::Plugin {
 public:
  static void RegisterWithRegistrar(flutter::PluginRegistrarWindows *registrar);

  NgexPlugin();

  virtual ~NgexPlugin();

  // Disallow copy and assign.
  NgexPlugin(const NgexPlugin&) = delete;
  NgexPlugin& operator=(const NgexPlugin&) = delete;

 private:
  // Called when a method is called on this plugin's channel from Dart.
  void HandleMethodCall(
      const flutter::MethodCall<flutter::EncodableValue> &method_call,
      std::unique_ptr<flutter::MethodResult<flutter::EncodableValue>> result);
};

}  // namespace ngex

#endif  // FLUTTER_PLUGIN_NGEX_PLUGIN_H_
