import 'package:flutter/material.dart';
import 'dart:math' as math;
import './store.dart';

class AppController extends Store {
  @override
  void initStore() {
    index.watch((s) => print("-> ${s}"));
    super.initStore();
  }

  Color randomColor() {
    return Color((math.Random().nextDouble() * 0xFFFFFF).toInt())
        .withOpacity(1.0);
  }
}
