import 'package:flutter/material.dart';

class NgexPreferred extends StatelessWidget implements PreferredSizeWidget {
  Widget child;
  double? height;
  NgexPreferred({Key? key, required this.child, this.height});
  @override
  Size get preferredSize => Size.fromHeight(height ?? 56.0);

  @override
  Widget build(BuildContext context) {
    return PreferredSize(
      preferredSize: preferredSize,
      child: child,
    );
  }
}
